/*
Copyright Caroline et Serge COUDÉ, (01/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiGeneral;

import javax.swing.*;
import java.beans.*;
import java.awt.*;
import java.io.File;
import javax.swing.border.*;
import java.awt.image.*;
import java.awt.event.*; 
import java.util.*;

public class ItemMire extends Box implements ComponentListener {
                          
  private final static long serialVersionUID = 1L;
                              
  private Mire _mire = null;
  private ResizeLabelFont _lDate = null;
  public static double ratio = 0.80; // largeur / hauteur
  private Font _police = new Font("SansSerif", Font.BOLD, 30);
  private PanelJeu _plateauJeu;
  private Dimension _derniereDimension;

  public ItemMire(PanelJeu pJeu) {
    super(BoxLayout.Y_AXIS);
    addComponentListener(this);
    _plateauJeu = pJeu;
    _mire = new Mire();
    _lDate = new ResizeLabelFont("", JLabel.CENTER);
    _lDate.setFont(_police);
    _lDate.setAlignmentX(CENTER_ALIGNMENT);
    add(_lDate);
    add(_mire);
    setBorder(BorderFactory.createLineBorder(Color.black));
    setOpaque(true);
    setBackground(Color.white);
    setDate(Calendar.getInstance());
  }      
    
  private void updateLabel() {
    _lDate.setPreferredSize(new Dimension(getWidth(), (int)((1-ratio)*getHeight())));
    _lDate.revalidate();
  }
  
  public void setDate(Calendar d) {
    String date = "" + (d.get(Calendar.DAY_OF_MONTH) < 10 ? "0" : "") + d.get(Calendar.DAY_OF_MONTH);
    date += "/";
    date += (d.get(Calendar.MONTH) < 9 ? "0" : "") + (d.get(Calendar.MONTH)+1);  
    _lDate.setText(date);
    updateLabel();  
  }
  
  public void setText(String s) {
    _lDate.setText(s);
    updateLabel();
  }
    
  public void setNbExercicesCorrects(int n) {
    _mire.setNbExercicesCorrects(n);
  }  

  public void setNbExercices(int n) {
    _mire.setNbExercices(n);
  } 

  public void setPreferredSize(Dimension d) {
    super.setPreferredSize(compileDimension(d));
  }
  
  public void setMinimumSize(Dimension d) {
    super.setMinimumSize(compileDimension(d));
  }
  
  public void setMaximumSize(Dimension d) {
    super.setMaximumSize(compileDimension(d));
  }
  
  public Dimension compileDimension(Dimension d) {
    if (d.width == d.height)
      d.height = (int)(d.width/ratio);
    return d; 
  
  }

  public void componentHidden(ComponentEvent e) {
  }

  public void componentMoved(ComponentEvent e) {
  }

  public void componentResized(ComponentEvent e) {
    if (isShowing() && !getSize().equals(_derniereDimension)) {
      _derniereDimension = getSize();
      Dimension d = getSize();
      int dWidth = (int)(d.height*ratio);
      if (dWidth < (int)(d.width*0.95) || dWidth > d.width) { // 0 ou - 5% du ratio
        final ItemMire _this = this;
        final int _width = d.width > d.height ? (int)(d.height*ratio) : d.width; 
        final int _height = (int)(_width/ratio);
        SwingUtilities.invokeLater(new Runnable(){
          public void run() {
            _this.setSize(_width, _height);
            _this.updateLabel();
          }
        });
      }    
      updateLabel();
     }  
  } 

  public void componentShown(ComponentEvent e) {
  }    
}