/*
Copyright Caroline et Serge COUDÉ, (04/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiGeneral;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.awt.image.*;

public class PanelJeu extends Panneau implements AWTEventListener {

  private final static long serialVersionUID = 1L;

  protected Souris _souris; 
  protected int _largeurPlateau;
  protected int _hauteurPlateau;
  protected Rectangle _rectEcran = null;
  protected ItemEleveGen _itemEleve = null;
  protected JPanel _pItemEleve = null;
  protected Box _pEvaluations = null;
  protected JPanel _pMain = null;
  protected ItemMire _mireCourante = null;
  protected Box _pMires = null;
  protected JScrollPane _scrollMires = null;
  protected int _nbSucces = 0;
  protected int _nbExercices = 0;
  protected boolean _reponseFaite = false;
  protected long _timestampStart;
  protected long _timestampStop;
  protected bouton _bStopEvaluation = null;
  protected bouton _bStopExercice = null;
  protected BarreProgression _bProgression = null;
	
  public PanelJeu(TbiApp app) {
    super(app);

    _bProgression = new BarreProgression("Chargement des éléments du plateau...");
    
    // souris		
    JLayeredPane layeredPane = _app.getLayeredPane();
    _souris = new Souris(_app);
    layeredPane.add(_souris, new Integer(-3000));
    Toolkit.getDefaultToolkit().addAWTEventListener(this, AWTEvent.MOUSE_MOTION_EVENT_MASK | AWTEvent.MOUSE_EVENT_MASK);
  
    // agencement
		setLayout(new BorderLayout());
		setBackground(Color.white);
    // stop exercice et evaluation si besoin
    try {
      _bStopEvaluation = new bouton(_app.getRessourceByConf("boutonstopevaluation"));
		  _bStopEvaluation.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
      _bStopExercice = new bouton(_app.getRessourceByConf("boutonstopexercice"));
		  _bStopExercice.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }    
		// panneau des évaluations
    _pEvaluations = Box.createVerticalBox(); 
    _pEvaluations.setOpaque(false);
    // affichage de l'image et du nom de l'élève
    _pItemEleve = new JPanel(new FlowLayout(FlowLayout.CENTER, 0, 0));
    _pItemEleve.setOpaque(true);
    _pItemEleve.setBackground(Color.red);
    JPanel pStops = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pStops.setOpaque(false);
    pStops.setPreferredSize(new Dimension((int)(_bStopEvaluation.getLargeur()*1.25), (int)(_bStopEvaluation.getHauteur()*1.25)));
    pStops.setMinimumSize(pStops.getPreferredSize());
    pStops.setMaximumSize(pStops.getPreferredSize()); 
    pStops.add(_bStopEvaluation);
    pStops.add(_bStopExercice);
    pStops.setAlignmentX(CENTER_ALIGNMENT);
    _pEvaluations.add(pStops);
    _pEvaluations.add(_pItemEleve);
    _pMires = Box.createVerticalBox();
    _pMires.setOpaque(false);
    _scrollMires = new JScrollPane(_pMires, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    _scrollMires.setOpaque(false);
    // affichage des mires de réussite
    _mireCourante = _app.genereItemMire(this);
    _pMires.add(_mireCourante);
    _pEvaluations.add(_scrollMires);
    _pEvaluations.add(Box.createVerticalGlue());
    // plateau de jeu par défaut
    _pMain = new JPanel();
    _pMain.setOpaque(false);
		add(_pEvaluations, BorderLayout.WEST);
    add(_pMain, BorderLayout.CENTER);
    _bStopEvaluation.setVisible(false);
    _bStopExercice.setVisible(true);
    _pEvaluations.setVisible(false);
    
  }
  
  public void actionPerformed(ActionEvent evt) {
		Object source = evt.getSource();
		if (source == _bStopExercice) {
		  stopExerciceEnCours(false);
    }
		if (source == _bStopEvaluation) {
		  stopExerciceEnCours(true);
    }
  }
  
  protected void centreBarreProgression() {
    _pMain.add(_bProgression);
    Dimension dim = getSize();
    _bProgression.setSize(new Dimension(dim.width/2,50));
    _bProgression.setLocation(dim.width/4,dim.height/3);
  }
  
  protected void retireBarreProgression() {
    _pMain.remove(_bProgression);
    repaint();
  }
  
  @Override
  public void init() {
    Eleve e = _app.getEleve();
    if (e != null) { 
      _itemEleve = e.getItemEleve();
      _pItemEleve.removeAll();
      _pItemEleve.add(_itemEleve);
    }
    if (_app.getUtilisationDesClasses()) {
      _pItemEleve.setVisible(true);
      if (_app.getEpreuve() != null)
        _app.getEpreuve().setEleve(e);
    } else
      _pItemEleve.setVisible(false);
    _nbSucces = 0;
    _nbExercices = 0;
    _mireCourante.setNbExercicesCorrects(_nbSucces);
    _mireCourante.setNbExercices(_app.getNbExercices());
    _mireCourante.setText("Aujourd'hui   ");
	  _app.majAffichage();
    nouvelExercice();
    setSouris(true);
    _app.genereMiresEvaluations(this, _mireCourante, _pMires);
    if (_app.getEvaluation() != null) {
      _bStopEvaluation.setVisible(true);
      _bStopExercice.setVisible(false);
    } else {
      _bStopEvaluation.setVisible(false);
      _bStopExercice.setVisible(true);
    }
    agenceLesComposants();    
  }
  
  public void agenceLesComposants() {
    Dimension d = getSize();
    int wEvaluations = d.width/10;
    int hEvaluations = d.height; 
    Dimension dEvaluations = new Dimension(wEvaluations, hEvaluations);
    _pEvaluations.setMinimumSize(dEvaluations);
    _pEvaluations.setPreferredSize(dEvaluations);
    _pEvaluations.setMaximumSize(dEvaluations);
    Dimension dMire = new Dimension(wEvaluations, wEvaluations);
    Component lesMires[] = _pMires.getComponents();
    for(int m = 0; m < lesMires.length; m++) {
      Component c = _pMires.getComponent(m);
      if (c instanceof ItemMire) { 
        ItemMire iMire = (ItemMire)c;
        iMire.setMinimumSize(dMire);
        iMire.setPreferredSize(dMire);
        iMire.setMaximumSize(dMire);
        iMire.revalidate();
      }
    }  
    if (_app.getUtilisationDesClasses()) {
 		  int wItemEleve = wEvaluations;
 		  int hItemEleve = (int)(wItemEleve / ItemEleve.ratio);
      Dimension dItemEleve = new Dimension(wItemEleve, hItemEleve);  
      _itemEleve.setPreferredSize(dItemEleve);
      _itemEleve.setMinimumSize(dItemEleve);
      _itemEleve.setMaximumSize(dItemEleve);
      _pItemEleve.setPreferredSize(dItemEleve);
      _pItemEleve.setMinimumSize(dItemEleve);
      _pItemEleve.setMaximumSize(dItemEleve);
    }
    revalidate();
  }
  
  public void nouvelExercice() {
    _reponseFaite = false;
    if (_nbExercices >= _app.getNbExercices()) 
      finExercice();
    else {
      if (_app.getUtilisationDesClasses()) {
        if (_app.getEpreuve() != null) {
          if (_app.getEpreuve().getExercice() != null)
            _app.getEpreuve().getExercice().stop(); 
          _app.getEpreuve().getNewExercice().start();
        }
      }
    }      
  }
  
  public void finExercice() {
    if (_app.getUtilisationDesClasses()) {
      if (_app.getEpreuve() != null)
        _app.getEpreuve().stop();
      _app.setPanneau("SelectEleveGen");
    } else 
      _app.setPanneau(_app.getPanneauApresSelectClasse("dernier"));
  }
  
  public void stopExerciceEnCours(boolean evaluationEnCours) {
    if (!evaluationEnCours) {
      if (_app.getUtilisationDesClasses()) {
        _itemEleve.selectionne(false);
        _app.setPanneau("SelectEleveGen");
      } else {
        _app.setPanneau(_app.getPanneauApresSelectClasse("dernier"));
      }
    } else {
      Eleve eleve = _itemEleve.getEleve(); 
      String mess = "Une évaluation est en cours pour l'élève " + eleve.getNomUsuel() + "...\nÊtes-vous sûr de vouloir arrêter son évaluation ?";
      int rep = JOptionPane.showConfirmDialog(_app.getPFrame(), mess, "Stopper", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
      if (rep == JOptionPane.NO_OPTION) 
            return;
      _app.annuleEpreuve();
      _itemEleve.selectionne(false);
      _app.setPanneau("SelectEleveGen");
    }
  }
  
  public void setSouris(boolean active) {
    if (active) {
      _souris.setTaille(_app.getTailleCurseur());
      GraphicsConfiguration gc = _app.getEcran().getDefaultConfiguration();
      _rectEcran = gc.getBounds();
     }
    _souris.setVisible(active);
    PointerInfo pointer = MouseInfo.getPointerInfo();
    Point locSouris = pointer.getLocation();
    SwingUtilities.convertPointFromScreen(locSouris, this);
    eventDispatched(new MouseEvent(this, MouseEvent.MOUSE_MOVED, Calendar.getInstance().getTimeInMillis(), 0, locSouris.x, locSouris.y, 0, false));       
  } 
  
  public void startChrono() {
    _timestampStart = System.currentTimeMillis();
  }

  public int stopChrono() {
    _timestampStop = System.currentTimeMillis();
    return (int)(_timestampStop-_timestampStart);
  }

  
  public void	eventDispatched(AWTEvent e) {
    if (e instanceof MouseEvent) {
      MouseEvent me = (MouseEvent)e;
      Point p = me.getLocationOnScreen();
      if (_rectEcran != null)
        _souris.setLocation(p.x-_rectEcran.x, p.y-_rectEcran.y);
      else
        _souris.setLocation(p.x, p.y-_souris.getHauteur());
    }     
  }
  
  public void succes() {
    if (!_reponseFaite) {
      _nbExercices++;
      _nbSucces++;
      _mireCourante.setNbExercicesCorrects(_nbSucces);
      if (_app.getUtilisationDesClasses())
        if (_app.getEpreuve() != null)  
          _app.getEpreuve().getExercice().setSucces(_nbExercices);
    }
    _reponseFaite = true;
    verifieFinExercices();
  }

  public void echec() {
    if (!_reponseFaite) {
      _nbExercices++;
      if (_app.getUtilisationDesClasses())
        if (_app.getEpreuve() != null) 
          _app.getEpreuve().getExercice().setEchec(_nbExercices);      
    }
    _reponseFaite = true;
    verifieFinExercices();
  }
  
  public boolean verifieFinExercices() {
     return _nbExercices >= _app.getNbExercices();
  }
  
  public PanelJeu getThis() {
    return this;
  }
 
}