/*
Copyright Caroline et Serge COUDÉ, (05/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiQuizzSonore;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import net.sergecoude.TbiGeneral.*;

public class PanelConfigQuizz extends PanelConfig {

  private final static long serialVersionUID = 1L;

  private JRadioButton _br2Illustrations, _br3Illustrations, _br4Illustrations;
  private JRadioButton _brAvecNom, _brSansNom;
  private JTextField _tfCheminDesThemes;  
  private bouton _bChoisir;
	
  public PanelConfigQuizz(TbiQuizzSonore app) {
    super(app);
		
		_br2Illustrations = new JRadioButton(" 2 ");
		_br2Illustrations.setFont(_police);
		_br2Illustrations.setOpaque(false);
		if (app.getNbImagesProposees() == 2)
      _br2Illustrations.setSelected(true);
    _br3Illustrations = new JRadioButton(" 3 ");
		_br3Illustrations.setFont(_police);
		_br3Illustrations.setOpaque(false);
		if (app.getNbImagesProposees() == 3)
      _br3Illustrations.setSelected(true);
    _br4Illustrations = new JRadioButton(" 4 ");
		_br4Illustrations.setFont(_police);
		_br4Illustrations.setOpaque(false);
		if (app.getNbImagesProposees() == 4)
      _br4Illustrations.setSelected(true);
    ButtonGroup group = new ButtonGroup();
    group.add(_br2Illustrations);
    group.add(_br3Illustrations);
    group.add(_br4Illustrations);
    JPanel pNbImages = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pNbImages.setOpaque(false);
    pNbImages.add(_br2Illustrations);
    pNbImages.add(_br3Illustrations);
    pNbImages.add(_br4Illustrations);
    JLabel lNbImages = new JLabel("Combien d'images peuvent être choisies ?", JLabel.CENTER);
    lNbImages.setFont(_police);
    lNbImages.setOpaque(true);
    lNbImages.setBackground(Color.lightGray);
    lNbImages.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel bNbImages = new JPanel(new FlowLayout(FlowLayout.CENTER));
    bNbImages.setOpaque(false);
    bNbImages.add(lNbImages);
    bNbImages.add(pNbImages);

    _brAvecNom = new JRadioButton("Oui");
		_brAvecNom.setFont(_police);
		_brAvecNom.setOpaque(false);
		_brAvecNom.setActionCommand("avecnom");
		if (((TbiQuizzSonore)_app).getAvecNomPrononce())
      _brAvecNom.setSelected(true);
    _brSansNom = new JRadioButton("Non");
		_brSansNom.setFont(_police);
		_brSansNom.setOpaque(false);
		_brSansNom.setActionCommand("sansnom");
		if (!((TbiQuizzSonore)_app).getAvecNomPrononce())
      _brSansNom.setSelected(true);
    ButtonGroup groupNom = new ButtonGroup();
    groupNom.add(_brAvecNom);
    groupNom.add(_brSansNom);
    JPanel pAvecSansNom = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pAvecSansNom.setOpaque(false);
    pAvecSansNom.add(_brAvecNom);
    pAvecSansNom.add(_brSansNom);
    pAvecSansNom.setAlignmentX(CENTER_ALIGNMENT);
    JLabel lAvecSansNom = new JLabel("Images avec le nom prononcé ?", JLabel.CENTER);
    lAvecSansNom.setFont(_police);
    lAvecSansNom.setOpaque(true);
    lAvecSansNom.setBackground(Color.lightGray);
    lAvecSansNom.setAlignmentX(Component.CENTER_ALIGNMENT);
    JPanel bAvecSansNom = new JPanel(new FlowLayout(FlowLayout.CENTER));
    bAvecSansNom.setOpaque(false);
    bAvecSansNom.add(lAvecSansNom);
    bAvecSansNom.add(pAvecSansNom);
    
    _tfCheminDesThemes = new JTextField("");
    _tfCheminDesThemes.setPreferredSize(new Dimension(400,30));
    _tfCheminDesThemes.setFont(_police);
    try {
      _bChoisir = new bouton(app.getRessourceByConf("boutonchoisir"));
      _bChoisir.addActionListener(this);
    } catch (Exception e) {
      _app.log(e);
    }
    JLabel lCheminDesThemes = new JLabel("Chemin des thèmes", JLabel.CENTER);
    lCheminDesThemes.setFont(_police);
    lCheminDesThemes.setOpaque(true);
    lCheminDesThemes.setBackground(Color.lightGray);
    JPanel pCheminDesThemes = new JPanel(new FlowLayout(FlowLayout.CENTER));
    pCheminDesThemes.setOpaque(false);
    pCheminDesThemes.add(lCheminDesThemes);    
    pCheminDesThemes.add(_tfCheminDesThemes);
    pCheminDesThemes.add(_bChoisir);
    pCheminDesThemes.setAlignmentX(Component.CENTER_ALIGNMENT);    

    _pConfExtends.setLayout(new BoxLayout(_pConfExtends, BoxLayout.PAGE_AXIS));
    _pConfExtends.add(bNbImages);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(bAvecSansNom);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
    _pConfExtends.add(pCheminDesThemes);
    _pConfExtends.add(Box.createRigidArea(new Dimension(0,10)));
  }
  
  protected void preEnregistrer() { // met à jour les config
    super.preEnregistrer();
  	if (_br2Illustrations.isSelected())
		  ((TbiQuizzSonore)_app).setNbImagesProposees(2);
		else if (_br3Illustrations.isSelected()) 
		  ((TbiQuizzSonore)_app).setNbImagesProposees(3);
 		else   
		  ((TbiQuizzSonore)_app).setNbImagesProposees(4);
		if (_brAvecNom.isSelected())
		  ((TbiQuizzSonore)_app).setAvecNomPrononce(true);
		else 
		  ((TbiQuizzSonore)_app).setAvecNomPrononce(false);
		((TbiQuizzSonore)_app).setCheminDesThemes(_tfCheminDesThemes.getText());
  }
  
  public void actionPerformed(ActionEvent evt) {
    super.actionPerformed(evt);
		Object source = evt.getSource();
		if (source == _bChoisir) {
		  JFileChooser chooser = new JFileChooser(_tfCheminDesThemes.getText());
		  chooser.setAcceptAllFileFilterUsed(false);
		  chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		  int ret = chooser.showDialog(_app, "Choisir le répertoire contenant les thèmes");
		  if (ret == JFileChooser.APPROVE_OPTION) {
        File file = chooser.getSelectedFile();
  			_tfCheminDesThemes.setText(file.getAbsolutePath());
      }
      chooser.setSelectedFile(null);      
		}
  }
  
  public void init(boolean defaut) {
    super.init(defaut);
    _br2Illustrations.setEnabled(true);
    _br3Illustrations.setEnabled(true);
    _br4Illustrations.setEnabled(true);
    _bSuivant.setEnabled(true);
    
    int nbimages = ((TbiQuizzSonore)_app).getNbImagesProposees();
    if (defaut)
      nbimages = Integer.parseInt(_app.getConfiguration(((TbiQuizzSonore)_app)._V_NbImagesProposees));
    if (nbimages == 2)
      _br2Illustrations.setSelected(true);
    else if (nbimages == 3)
      _br3Illustrations.setSelected(true);
    else
      _br4Illustrations.setSelected(true);
    
    String chemin = ((TbiQuizzSonore)_app).getCheminDesThemes();
    if (defaut)
      chemin = _app.getConfiguration(((TbiQuizzSonore)_app)._V_CheminDesThemes);   
    _tfCheminDesThemes.setText(chemin);
    
    boolean nomprononce = ((TbiQuizzSonore)_app).getAvecNomPrononce();
    if (defaut)
      nomprononce = _app.getConfiguration(((TbiQuizzSonore)_app)._V_NomPrononce).toLowerCase().equals("oui") ? true : false; 
    if (nomprononce) 
      _brAvecNom.setSelected(true);
    else
      _brSansNom.setSelected(true);
  }
  
}
