/*
Copyright Caroline et Serge COUDÉ, (09/2012) 

serge.coude@gmail.com caroline.coude@laposte.net

Ce logiciel est un programme informatique faisant partie d'une suite de 
logiciels 'TbiSuite' à destination des enseignants et des élèves usagés des 
ordinateurs et Tableau Numérique Interactif / Tableau Blanc Interactif. 

Ce logiciel est régi par la licence CeCILL v2 soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL v2 telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL v2, et que vous en avez accepté les
termes.

*/
package net.sergecoude.TbiQuizzSonore;

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.image.*;
import javax.imageio.*;
import net.sergecoude.TbiGeneral.*;

public class PanelTableauJeu extends PanelJeu {

  private final static long serialVersionUID = 1L;

  private Box _pVignettes;
  private Box _pBas;
  private JPanel _pBSuivantFini;
  private bouton _bEcouter;
  private bouton _bFini;
  private bouton _bOK;
  private bouton _bKO;
  private Vector<Element> _lesElementsPresentes;
  private Vector<Element> _lesElementsNonPresentes;
  private Element _elementReponse;
  private Theme _theme;
  private int _etat; // 1 : l'exercice est initialisé / 2 : bouton écouter cliqué / 3 : une vignette au moins a été cliquée
  private int _dxVignettes = 30;
  public static int largeurVignette = 200;
  public static int hauteurVignette = 200;
  
  public PanelTableauJeu(TbiQuizzSonore app) {
    super(app);
		if (_app.getSkin() == null) {
		  _app.messageStatique("Pas d'habillage (" + _app.getNomDuSkin() + ") trouvé...", _app.MESSAGE_ERREUR);
		  System.exit(-1);
    }
    try {
      _bEcouter = new bouton(_app.getSkin().getRessource("ecouter"));
		  _bEcouter.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
  		_bSuivant = new bouton(_app.getSkin().getRessource("suivant"));
	   	_bSuivant.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
  		_bFini = new bouton(_app.getSkin().getRessource("fini"));
	   	_bFini.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
		  _bOK = new bouton(_app.getSkin().getRessource("ok"));
		  _bOK.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
    try {
		  _bKO = new bouton(_app.getSkin().getRessource("ko"));
		  _bKO.addActionListener(this);
    } catch(Exception e) {
      _app.log(e);
    }
		
		_pMain.setLayout(new BorderLayout()); // définition à faire
     
		_pBas = Box.createHorizontalBox();
		_pBas.setOpaque(false);
		_pBas.add(Box.createHorizontalGlue());
		_pBas.add(_bEcouter);
		_pBas.add(Box.createHorizontalGlue());
		
		_pBSuivantFini = new JPanel(new CardLayout());
		_pBSuivantFini.setOpaque(false);
		_pBSuivantFini.add(_bSuivant, "suivant");
		_pBSuivantFini.add(_bFini, "fini");
		_pBas.add(_pBSuivantFini);
		_pMain.add(_pBas, BorderLayout.SOUTH);
		_pVignettes = Box.createHorizontalBox();
		_pVignettes.setOpaque(false);
		Box pMilieu = Box.createVerticalBox();
		pMilieu.add(Box.createVerticalGlue());
		pMilieu.add(_pVignettes);
		pMilieu.add(Box.createVerticalGlue());
		_pMain.add(pMilieu);
    
    _lesElementsPresentes = new Vector<Element>();
    _lesElementsNonPresentes = new Vector<Element>();
    _etat = 1;
    _pEvaluations.setVisible(true); 
  }
  
  public void actionPerformed(ActionEvent evt) {
    super.actionPerformed(evt);
		Object source = evt.getSource();
	  if (source == _bEcouter) {
	    agenceLesVignettes(); // réaffichage des images 
	    try {
	     _app.play(_elementReponse.getFichierSon().toURI().toURL());
	    } catch (MalformedURLException mue) {
	     _app.message(mue.toString(), _app.MESSAGE_ERREUR);
      }
	    if (_etat == 1) {
        startChrono(); // démarrage du chrono à la première écoute
        _etat = 2;
      }
    } else if (source == _bSuivant) {
      if (_etat >= 3) { // si l'élève a au moins déja cliqué sur écouter et sur une image
        _app.stopPlayer();
        nouvelExercice();
      }
    } else if (source == _bFini) {
      finExercice();
    } else if (source == _bOK) {
      agenceLesVignettes(); // réaffichage des images précédentes
      verifieFinExercices();
    } else if (source == _bKO) {
      agenceLesVignettes(); // réaffichage des images précédentes
      verifieFinExercices();
    } else  { // c'est une image cliquée
      // diffusion du nom
      int duree = stopChrono();
      Element choix = null;
      for(int i = 0; i < _lesElementsPresentes.size(); i++) {
        choix = _lesElementsPresentes.elementAt(i);
        if (choix.getVignette() == source) {
          if (((TbiQuizzSonore)_app).getAvecNomPrononce()) {
            try {
              _app.play(choix.getFichierNom().toURI().toURL());
  	        } catch (MalformedURLException mue) {
  	         _app.message(mue.toString(), _app.MESSAGE_ERREUR);
            }
          } else
            _app.stopPlayer();           
          break;
        }
      }
      if (_etat >= 2) { // il faut au moins avoir deja écouté le son
        final boolean bSucces = ((source == _elementReponse.getVignette()) ? true : (_theme.verifieCompatibilite(choix, _elementReponse) == Configuration.CONFIGURATION_TYPE_EQUIVALENCE_ID ? true : false));  
        if (_app.getUtilisationDesClasses()) {
          if (_app.getEpreuve() != null) {
            ((ExerciceQuizz)((EpreuveQuizz)_app.getEpreuve()).getExercice()).addEnregistrement(choix, duree, bSucces);
          }
        }
        if (((TbiQuizzSonore)_app).getAvecNomPrononce()) {
          Thread tAttente = new Thread() {
            public void run() {
              try { 
                while(_app.isPlaying()) {
                  sleep(20);
                }
                sleep(750); // on patiente 3/4 de seconde avant d'afficher le simley (le temps de la fin de la diffusion)
                gereReponse(bSucces);
              } catch (Exception e) { 
              }
            }
          };
          tAttente.start();
        } else {
          gereReponse(bSucces);        
        }
      } 
    }
  }
  
  public void gereReponse(boolean bSucces) {
    Component lesVignettes[] = _pVignettes.getComponents();
    for(int v = 0; v < lesVignettes.length; v++)
      if (lesVignettes[v] instanceof bouton)
        lesVignettes[v].setVisible(false);
    _pVignettes.removeAll();
    _pVignettes.validate(); // on acte qu'il n'y a plus rien
    if (bSucces)
      succes();
    else
      echec();
    _pVignettes.validate();
    _etat = 3;
  }
  
  public void succes() {
    super.succes();
    // on centre le smiley
    _pVignettes.add(Box.createHorizontalGlue());    
    _pVignettes.add(_bOK);
    _pVignettes.add(Box.createHorizontalGlue());
    _bOK.setVisible(true);
  }

  public void echec() {
    super.echec();
    // on centre le smiley
    _pVignettes.add(Box.createHorizontalGlue());    
    _pVignettes.add(_bKO);
    _pVignettes.add(Box.createHorizontalGlue());
    _bKO.setVisible(true);
  }

  public void init() {
    _theme = ((TbiQuizzSonore)_app).getThemeSelectionne();
    _lesElementsPresentes.clear();
    _lesElementsNonPresentes.clear();
    super.init();
    CardLayout cl = (CardLayout)_pBSuivantFini.getLayout();
    cl.show(_pBSuivantFini,"suivant");
    _pBSuivantFini.setVisible(false);
  }

  public void nouvelExercice() {
    super.nouvelExercice();
    _etat = 1;
    _lesElementsPresentes.clear();
    if (_theme != null) {
      if (_lesElementsNonPresentes.size() == 0) { // on recommence  
        for(int i = 0; i < _theme.getNbElements(); i++) 
          _lesElementsNonPresentes.add(_theme.elementAt(i));
      }
      int idxReponse = (int)(Math.random() * (_lesElementsNonPresentes.size()-0)) + 0;
      _elementReponse = _lesElementsNonPresentes.elementAt(idxReponse);
      if (_app.getEpreuve() != null && _app.getEpreuve().getExercice() != null)
        ((ExerciceQuizz)(_app.getEpreuve().getExercice())).setBonneReponse(_elementReponse);
      _lesElementsPresentes.add(_elementReponse); // on ajoute la bonne réponse dans les choix possibles proposés 
      _lesElementsNonPresentes.remove(_elementReponse); // on la retire du panier pour les exercices suivants
      Vector<Element> lesElementsPossibles = new Vector<Element>();
      for(int e = 0; e < _theme.getNbElements(); e++)
        lesElementsPossibles.add(_theme.elementAt(e));
      lesElementsPossibles.remove(_elementReponse);
      // premier tri : on retire les éléments incompatibles avec la réponse
      for(int e = 0; e < lesElementsPossibles.size(); e++)
        if (_theme.verifieCompatibilite(lesElementsPossibles.elementAt(e), _elementReponse) == Configuration.CONFIGURATION_TYPE_NON_ACCORD_ID)
          lesElementsPossibles.remove(lesElementsPossibles.elementAt(e));
      // second tri : on retire les éléments incompatibles entre eux (un des deux)
      for(int e1 = 0; e1 < lesElementsPossibles.size()-1; e1++)
        for(int e2 = e1+1; e2 < lesElementsPossibles.size(); e2++)
          if (_theme.verifieCompatibilite(lesElementsPossibles.elementAt(e1), lesElementsPossibles.elementAt(e2)) == Configuration.CONFIGURATION_TYPE_NON_ACCORD_ID)
            lesElementsPossibles.remove(lesElementsPossibles.elementAt(e2));
      // on "distribue les cartes"      
      for(int i = 0; i < ((TbiQuizzSonore)_app).getNbImagesProposees()-1; i++) { 
        int idx = (int)(Math.random() * (lesElementsPossibles.size()-0)) + 0;
        Element elemPropose = lesElementsPossibles.elementAt(idx);
        _lesElementsPresentes.add(elemPropose);
        lesElementsPossibles.remove(elemPropose);
      }
      Collections.shuffle(_lesElementsPresentes);
      lesElementsPossibles.clear();
      agenceLesVignettes();
    }
  }
  
  public void agenceLesVignettes() {
    Component lesVignettes[] = _pVignettes.getComponents();
    for(int v = 0; v < lesVignettes.length; v++) 
      if (lesVignettes[v] instanceof bouton) 
        lesVignettes[v].setVisible(false);
    _pVignettes.removeAll();
    Dimension dim = getSize();
    _largeurPlateau = dim.width;
    int lVignette = largeurVignette;
    int hVignette = hauteurVignette;
    int nbVignettes = 4;
    int dxVignettes = (int)(_dxVignettes * (_app.getHauteurTbi() / 768f));
    if (_largeurPlateau - ((nbVignettes * lVignette) - ((nbVignettes+1) * dxVignettes*2)) < 0) {
      lVignette = (_largeurPlateau - (nbVignettes+1) * dxVignettes) / nbVignettes;
      hVignette = lVignette; 
    }
    nbVignettes = _lesElementsPresentes.size();
    _pVignettes.add(Box.createHorizontalGlue());
    for(int i = 0; i < _lesElementsPresentes.size(); i++) {
      Element elem = _lesElementsPresentes.elementAt(i);
      bouton vignette = elem.getVignette();
      vignette.setDimension(lVignette, hVignette);
      vignette.addActionListener(this);
      vignette.setVisible(true); 
      _pVignettes.add(vignette);
      _pVignettes.add(Box.createHorizontalGlue());      
    }
    _bEcouter.setDimension(lVignette, hVignette);
    _bSuivant.setDimension(lVignette, hVignette);
    _bFini.setDimension(lVignette, hVignette);
    
    int wBSuivantFini = lVignette;
    int hBSuivantFini = hVignette; 
    Dimension dBSuivantFini = new Dimension(wBSuivantFini, hBSuivantFini);
    _pBSuivantFini.setMinimumSize(dBSuivantFini);
    _pBSuivantFini.setPreferredSize(dBSuivantFini);
    _pBSuivantFini.setMaximumSize(dBSuivantFini);
    
//    _bOK.setDimension((int)(1.5*lVignette), (int)(1.5*hVignette));
//    _bKO.setDimension((int)(1.5*lVignette), (int)(1.5*hVignette));
    
    _pVignettes.validate();
  }
  
  public boolean verifieFinExercices() {
    _pBSuivantFini.setVisible(true);
    if (super.verifieFinExercices()) {
      CardLayout cl = (CardLayout)_pBSuivantFini.getLayout();
      cl.show(_pBSuivantFini, "fini");
      return true; 
    } else {
      if (!_bSuivant.isVisible())
        _bSuivant.setVisible(true);
      return false;
    }
  }
  
}